{*******************************************************}
{*  CadoDraw for Delphi examples                   *}
{*  Copyright (c) 1997 Alfred Lorenz                   *}
{*  All Rights Reserved                                *}
{*  internet mail support@LTS-Tools.com                *}
{*  word wide web http://www.LTS-Tools.com             *}
{*                                                     *}
{*  You are not allowed to redistribute this           *}
{*  code or any part of it                             *}
{*******************************************************}

unit ActDiaFm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Cadodraw, Markmove, Scales, Buttons, StdCtrls, Cdprint2,
  Texttool, Scl12;

type
  TForm1 = class(TForm)
    cdDrawbox1: TcdDrawbox;
    MarkMove1: TMarkMove;
    LineDepends1: TLineDepends;
    cdPoints1: TcdPoints;
    tcdDataModule1: tcdDataModule;
    VertLine: TLineDepends;
    AreaTTL: TLabel;
    AreaLab: TLabel;
    MeanTTL: TLabel;
    MeanLab: TLabel;
    PrintBtn: TButton;
    cdPrinter1: TcdPrinter;
    cdScales1: TcdScales;
    PrinterSetupDialog1: TPrinterSetupDialog;
    SetupBtn: TButton;
    TendencyLine: TcdLines;
    TendBtn: TButton;
    BitBtn1: TBitBtn;
    procedure cdDrawbox1PredefineObjects(Sender: TObject);
    procedure MarkMove1ObjectEndMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure PrintBtnClick(Sender: TObject);
    procedure cdPoints1ObjectDraw(CurrentObject: TcdObject);
    procedure SetupBtnClick(Sender: TObject);
    procedure TendBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure CalcArea;

  end;



var
  Form1: TForm1;
  Tendency: TLineObj;
  ShowTendency: boolean;


implementation

{$R *.DFM}


procedure TForm1.cdDrawbox1PredefineObjects(Sender: TObject);
begin
  LineDepends1.SetNewObj(Point(0,400));
  LineDepends1.SetNewObj(Point(100,450));
  LineDepends1.SetNewObj(Point(200,500));
  LineDepends1.SetNewObj(Point(300,550));
  LineDepends1.SetNewObj(Point(400,400));
  LineDepends1.SetNewObj(Point(500,400));
  LineDepends1.SetNewObj(Point(600,300));
  LineDepends1.SetNewObj(Point(700,250));
  LineDepends1.SetNewObj(Point(800,200));
  VertLine.LinkNewObj(Point(100,450));
  VertLine.SetNewObj(Point(100,0));
  VertLine.LinkNewObj(Point(200,500));
  VertLine.SetNewObj(Point(200,0));
  VertLine.LinkNewObj(Point(300,550));
  VertLine.SetNewObj(Point(300,0));
  VertLine.LinkNewObj(Point(400,400));
  VertLine.SetNewObj(Point(400,0));
  VertLine.LinkNewObj(Point(500,400));
  VertLine.SetNewObj(Point(500,0));
  VertLine.LinkNewObj(Point(600,300));
  VertLine.SetNewObj(Point(600,0));
  VertLine.LinkNewObj(Point(700,250));
  VertLine.SetNewObj(Point(700,0));
  VertLine.SetNewObj(Point(800,200));
  TendencyLine.SetNewObj(Point(0,200));
  Tendency:= TendencyLine.SetNewObj(Point(800,200));
  Tendency.visible:= false;
end;

procedure TForm1.MarkMove1ObjectEndMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  CalcArea;
end;

const Prec = 10;
procedure TForm1.CalcArea;
Var Area,
    LinCount,
    Mean,
    I,
    MinVal, MaxVal: integer;
    NumStr: String[10];
    ValPoints: Array[1..10] of tPoint;

  procedure calcTendency;
  Var xM,yM,dy,
      T,
      J: integer;
      SumDeltaTop, SumDeltaBot,
      M: Real;
  begin
    {initial }
    M:= 0;
    T:= MinVal;
    xM:= ValPoints[Lincount+1].x;
    yM:= 0;
    dy:= MaxVal - MinVal;
    Repeat
      SumDeltaTop:= 0;
      For J:= 1 to Lincount+1 do
        SumDeltaTop:= SumDeltaTop + abs(ValPoints[J].y - (M * ValPoints[J].x + T + dy));
      SumDeltaBot:= 0;
      For J:= 1 to Lincount+1 do
        SumDeltaBot:= SumDeltaBot + abs(ValPoints[J].y - (M * ValPoints[J].x + T - dy));
      if SumDeltaTop > SumDeltaBot then T:= T - dy
      else T:= T + dy;
      dy:= dy div 2;

    until dy < Prec;
   dY:= MaxVal - MinVal;
     {iteration}
    Repeat
      M:= (yM + dy) / xM;
      SumDeltaTop:= 0;
      For J:= 1 to Lincount+1 do
        SumDeltaTop:= SumDeltaTop + abs(ValPoints[J].y - (M * ValPoints[J].x + T));
      M:= (yM - dy) / xM;
      SumDeltaBot:= 0;
      For J:= 1 to Lincount+1 do
        SumDeltaBot:= SumDeltaBot + abs(ValPoints[J].y - (M * ValPoints[J].x + T));
      if SumDeltaTop > SumDeltaBot then yM:= yM - dy
      else yM:= yM + dy;
      dy:= dy div 2;
    until dy < Prec;
    Tendency.visible:= true;
    Tendency.Invalidate;
    Tendency.Y2_Log:= yM + T;
    Tendency.Y_Log:= T;
    Tendency.Invalidate;
    cdDrawBox1.invalidateRestoreRect;
  end;

begin
  Area:= 0;
  Mean:= 0;
  LinCount:= 0;
  MinVal:= maxInt;
  MaxVal:= -MaxInt;
  with tcdDataModule1.Objects do
  For I:= 0 to Count-1 do
  if TcdObject(Items[I]).Tool = LineDepends1 then with TLineObj(Items[I]) do
  begin
    inc(LinCount);
    ValPoints[LinCount]:= Pos_Log;
    if ValPoints[LinCount].Y < MinVal then MinVal:= ValPoints[LinCount].Y
    else if ValPoints[LinCount].Y > MaxVal then MaxVal:= ValPoints[LinCount].Y;
    Area:= Area + (Y2_Log + Y_Log) * abs(X2_log - X_log) div 2;
    Mean:= Mean +  Y_Log;
    ValPoints[LinCount + 1]:= Pos2_Log;
  end;
  Mean:= Mean +  ValPoints[LinCount + 1].Y;
  Mean:= Mean div (LinCount+1);
  Str(Area, NumStr);
  AreaLab.Caption:= NumStr;
  Str(Mean, NumStr);
  MeanLab.Caption:= NumStr;
  if ShowTendency then calcTendency;
 end;

procedure TForm1.PrintBtnClick(Sender: TObject);
begin
  cdPrinter1.print;
end;

procedure TForm1.cdPoints1ObjectDraw(CurrentObject: TcdObject);
begin
  //leer;
end;

procedure TForm1.SetupBtnClick(Sender: TObject);
begin
  PrinterSetupDialog1.execute;
end;

procedure TForm1.TendBtnClick(Sender: TObject);
begin
  ShowTendency:= not ShowTendency;
  if ShowTendency then CalcArea
  else Tendency.hide;
end;

end.
