unit PipeFm;

interface

uses
{$ifdef win32}
   windows,
{$else}
   WinTypes, WinProcs,
{$endif} {win32}
  SysUtils, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Markmove, Texttool, Cadodraw,
  ExtCtrls, Menus, Scl12;


// Used CadoDraw Components
//
// cdDrawbox
//   properties:     Align alClient;
//                   Color clWhite;
//                   ScaleSetting.MinUnit dm;
//                   ScaleSetting.rcp_Scale 1000;
//                   ScaleSetting.rcp_Limit 500;
// cdDataModule
//   properties:     Capacity 100;
// cdPoints
//   properties:     Cursor crUpArrow;
//                   Generator.Brush.Color clAqua;
//                   Generator.Counter 1;
//                   Generator.Height 10;
//                   Generator.Width 10;
//                   Generator.HotSpotX,Y 5;
//                   Generator.Shape stCircle;
//                   Generator.zOrder 3;
//                   SlaveObject KnotenLab;
// LineDepends
//   properties:     Button KanalBtn;
//                   Generator.Counter 2;
//                   Generator.Pen.Color clGreen;
//                   Generator.zOrder 4;
//                   MasterObject Knoten;
//                   Options [toPolyShape];
//                   SlaveObject RohrLab;
//   events:         OnActivate;
//                   OnTerminate;
//                   OnObjectSetClass;
//                   OnObjectSetData;
// cdLabels
//   properties:     Generator.Brush.Color clPurple;
//                   Generator.Font.Color clWhite;
//                   Generator.Font.Name Arial;
//                   Generator.Font.Size 22;
//                   Generator.Shape stEllipse;
//                   Generator.SlaveX -10;
//                   Generator.SlaveX 5;
//                   Generator.zOrder 2;
//                   Name KnotenLab;
//   events:         OnObjectSetData;
// cdLabels
//   properties:     Generator.Font.Name Arial;
//                   Generator.Font.Size 16;
//                   Generator.FrameDX,DY 3;
//                   Generator.zOrder 1;
//                   Name RohrLab;
//   events:         OnObjectSetData;
// MarkMove
//   properties:     Button Button1;
//                   Delay 100;
//                   Options [toDefaultTool, toHidePicture];
//   events:         ObjectDblClick;





type
  TPipeObj = class(tLineObj)
  private
    function GetL_World: Real;
  public
    Material: String[5];
    DN: integer;
    procedure SaveToStream(Stream: TStream);override;
    procedure LoadFromStream(Stream: TStream);override;
    procedure Edit;
    property L_World: Real read GetL_World;
  end;

  TForm2 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    cdDrawbox1: TcdDrawbox;
    DataMod: tcdDataModule;
    Pipe: TLineDepends;
    Knoten: TcdPoints;
    KnotenLab: TcdLabels;
    PipeLab: TcdLabels;
    MarkMove1: TMarkMove;
    PipesBtn: TSpeedButton;
    DNCombo: TComboBox;
    DNLab: TLabel;
    MaterialLab: TLabel;
    MaterialCombo: TComboBox;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Laden1: TMenuItem;
    Sichern1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Ansicht1: TMenuItem;
    Mastab1: TMenuItem;
    N110001: TMenuItem;
    N120001: TMenuItem;
    N150001: TMenuItem;
    Vollbild1: TMenuItem;
    Label1: TLabel;
    Berechnung1: TMenuItem;
    Lnge1: TMenuItem;
    MLab: TLabel;
    DelBtn: TButton;
    BitBtn1: TBitBtn;
    procedure KnotenLabObjectSetData(CurrentObject: TcdObject);
    procedure PipeLabObjectSetData(CurrentObject: TcdObject);
    procedure PipeObjectSetClass(var NewObjectClass: TCapClass);
    procedure PipeObjectSetData(CurrentObject: TcdObject);
    procedure PipeActivate(Sender: TObject);
    procedure PipeTerminate(Sender: TObject);
    procedure Laden1Click(Sender: TObject);
    procedure Sichern1Click(Sender: TObject);
    procedure MarkMove1ObjectDblClick(CurrentObject: TcdObject);
    procedure Vollbild1Click(Sender: TObject);
    procedure Lnge1Click(Sender: TObject);
    procedure cdDrawbox1ScaleChange(Sender: TObject);
    procedure MarkMove1Activate(Sender: TObject);
    procedure MarkMove1Terminate(Sender: TObject);
    procedure DelBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

uses PipeInfo;

{$R *.DFM}

procedure TPipeObj.SaveToStream(Stream: TStream);
begin
  inherited SaveToStream(Stream);
  Stream.write(Material, SizeOf(Material));
  Stream.write(DN, SizeOf(DN));
end;

procedure TPipeObj.LoadFromStream(Stream: TStream);
begin
  inherited LoadFromStream(Stream);
  Stream.read(Material, SizeOf(Material));
  Stream.read(DN, SizeOf(DN));
end;

procedure TPipeObj.Edit;
begin
  PipeEditor:= tPipeEditor.create(NIL);
  with PipeEditor do
  begin
    IDLab.Caption:= IntToStr(ID);
    KN1Lab.Caption:= IntToStr(Master.ID);
    KN2Lab.Caption:= IntToStr(Master2.ID);
    DNLab.Caption:= IntToStr(DN);
    MatLab.Caption:= Material;

    Showmodal;
  end;
end;

function TPipeObj.GetL_World: Real;
begin
  result:= sqrt(sqr(X_World - X2_World) + sqr(Y_World - Y2_World));
end;

procedure TForm2.KnotenLabObjectSetData(CurrentObject: TcdObject);
begin
  TLabelObj(CurrentObject).Text:= IntToStr(CurrentObject.Master.ID);
end;

function CalcLabelX(AnyRohr: TLineObj): integer;
begin
  result:= (AnyRohr.X2_Log + AnyRohr.X_Log) div 2;
end;

function CalcLabelY(AnyRohr: TLineObj): integer;
begin
  result:= (AnyRohr.Y2_Log + AnyRohr.Y_Log) div 2;
end;

procedure TForm2.PipeLabObjectSetData(CurrentObject: TcdObject);
begin
  TLabelObj(CurrentObject).Text:= MaterialCombo.Text + ' DN '
                                  + DNCombo.Text;
  CurrentObject.X_Log:= CalcLabelX(TLineObj(CurrentObject.Master));
  CurrentObject.Y_Log:= CalcLabelY(TLineObj(CurrentObject.Master));
end;

procedure TForm2.PipeObjectSetClass(var NewObjectClass: TCapClass);
begin
  NewObjectClass:= TPipeObj;
end;

procedure TForm2.PipeObjectSetData(CurrentObject: TcdObject);
begin
  TPipeObj(CurrentObject).DN:= StrToInt(DNCombo.Text);
  TPipeObj(CurrentObject).Material:= MaterialCombo.Text;
end;

procedure TForm2.PipeActivate(Sender: TObject);
begin
  MaterialLab.visible:= true;
  MaterialCombo.visible:= true;
  DNLab.visible:= true;
  DNCombo.visible:= true;
end;

procedure TForm2.PipeTerminate(Sender: TObject);
begin
  MaterialLab.visible:= false;
  MaterialCombo.visible:= false;
  DNLab.visible:= false;
  DNCombo.visible:= false;
end;

procedure TForm2.Laden1Click(Sender: TObject);
Var Stream: TStream;
begin
  if OpenDialog1.execute then
  begin
    Stream:= tFileStream.create(OpenDialog1.FileName, fmOpenRead);
    try
      cdDrawBox1.DataModule.LoadFromStream(Stream);
    finally
      Stream.Free;
    end;
    cdDrawBox1.Setscale(0);
  end;
end;

procedure TForm2.Sichern1Click(Sender: TObject);
Var Stream: TStream;
begin
  if SaveDialog1.execute then
  begin
    Stream:= tFileStream.create(SaveDialog1.FileName, fmCreate);
    cdDrawBox1.DataModule.SaveToStream(Stream);
    Stream.Free;
  end;
end;

procedure TForm2.MarkMove1ObjectDblClick(CurrentObject: TcdObject);
begin
  if CurrentObject is TPipeObj then TPipeObj(CurrentObject).Edit;
end;

procedure TForm2.Vollbild1Click(Sender: TObject);
begin
  if Sender = N110001 then cdDrawbox1.SetScale(1/1000)
  else if Sender = N120001 then cdDrawbox1.SetScale(1/2000)
  else if Sender = N150001 then cdDrawbox1.SetScale(1/5000)
  else if Sender = Vollbild1 then cdDrawbox1.SetScale(0);
end;

procedure TForm2.Lnge1Click(Sender: TObject);
Var I: integer;
    GesamtL: Real;
    NumStr: String[10];
begin
  GesamtL:= 0;
  With DataMod.Objects do
  For I:= 0 to Count-1 do
    if TcdObject(Items[I]) is TPipeObj then
    GesamtL:= GesamtL + TPipeObj(Items[I]).L_World;
  Str(GesamtL:10:2, NumStr);
  MessageDlg('Sum of the pipe lengths is ' + NumStr + ' m', mtInformation,
             [mbOK], 0);
end;

procedure TForm2.cdDrawbox1ScaleChange(Sender: TObject);
begin
  MLab.Caption:= 'M 1:' + IntToStr(cdDrawbox1.ScaleSetting.rcp_Scale);
end;

procedure TForm2.MarkMove1Activate(Sender: TObject);
begin
  DelBtn.Visible:= true;
end;

procedure TForm2.MarkMove1Terminate(Sender: TObject);
begin
  DelBtn.Visible:= false;
end;

procedure TForm2.DelBtnClick(Sender: TObject);
begin
  DataMod.DeleteObjects;
end;

end.
