{*******************************************************}
{*  CadoDraw for Delphi examples                   *}
{*  Copyright (c) 1997 Alfred Lorenz                   *}
{*  All Rights Reserved                                *}
{*  internet mail support@LTS-Tools.com                *}
{*  word wide web http://www.LTS-Tools.com             *}
{*                                                     *}
{*  You are not allowed to redistribute this           *}
{*  code or any part of it                             *}
{*******************************************************}

unit ShapeFm;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Markmove, Buttons, ExtCtrls,
  StdCtrls, Cadodraw, Scl12;


// Used Components
// cdDrawbox
//   Properties:     Align alClient;
//                   ScaleSetting.MinUnit cm;
//                   ScaleSetting.rcp_Scale 50;
//                   ScaleSetting.rcp_Limit 10;
//   Events:         OnMouseMove;
//                   OnScaleChange;
// cdPoints
//   Properties:     Button Button1;
//                   Generator.Height 80;
//                   Generator.Width  40;
//   Events:         OnObjectShape;
//                   OnObjectDraw;
//                   OnObjectCheckShape;
// MarkMove
//   Properties:     Options [toDefaultTool];





type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    cdPoints1: TcdPoints;
    MarkMove1: TMarkMove;
    Button1: TButton;
    Label1: TLabel;
    XLab: TLabel;
    Label3: TLabel;
    YLab: TLabel;
    ScaleLab: TLabel;
    Button2: TButton;
    cdDrawbox1: TcdDrawbox;
    tcdDataModule1: tcdDataModule;
    Label2: TLabel;
    Label4: TLabel;
    HelpBtn: TBitBtn;
    procedure cdPoints1ObjectShape(CurrentObject: TcdObject);
    procedure cdPoints1ObjectDraw(CurrentObject: TcdObject);
    procedure cdPoints1ObjectCheckShape(CurrentObject: TcdObject; x,
      y: Integer; var found: Boolean);
    procedure cdDrawbox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure cdDrawbox1ScaleChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    function createShapeRgn: hRgn;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.createShapeRgn: hRgn;
Var Rgn1, Rgn2: hRgn;
begin
  Rgn1:= createEllipticRgn(0,20,40,80);
  Rgn2:= createEllipticRgn(0,70,10,80);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(30,70,40,80);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(5,40,15,46);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(25,40,35,46);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(15,0,20,20);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(20,0,25,20);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  Rgn2:= createEllipticRgn(10,10,30,30);
  combineRgn(Rgn1, Rgn1, Rgn2, Rgn_OR);
  DeleteObject(Rgn2);
  result:= Rgn1;
end;

procedure TForm1.cdPoints1ObjectShape(CurrentObject: TcdObject);
Var ShapeRgn: hRgn;
begin
  ShapeRgn:= CreateShapeRgn;
  with ActScaleSet.Canvas do
  begin
    Brush.Color:= Pen.Color;
    Brush.Style:= bsSolid;
    FrameRgn(Handle,ShapeRgn,Brush.Handle,1,1);
  end;
  DeleteObject(ShapeRgn);
end;

procedure TForm1.cdPoints1ObjectDraw(CurrentObject: TcdObject);
begin
  with ActScaleSet.Canvas do
  begin
    Ellipse(0,20,40,80);
    Ellipse(0,70,10,80);
    Ellipse(30,70,40,80);
    Ellipse(5,40,15,46);
    Ellipse(25,40,35,46);
    Ellipse(15,0,20,20);
    Ellipse(20,0,25,20);
    Ellipse(10,10,30,30);
  end;
end;

procedure TForm1.cdPoints1ObjectCheckShape(CurrentObject: TcdObject; x,
  y: Integer; var found: Boolean);
Var ShapeRgn: hRgn;
Begin
  ShapeRgn:= CreateShapeRgn;
  found:= PtInRegion(ShapeRgn, X, Y);
  DeleteObject(ShapeRgn);
end;

procedure TForm1.cdDrawbox1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
Var NumStr: String[6];
begin
  Str(ActScaleSet.LogToWorld(X):3:2, NumStr);
  XLab.Caption:= NumStr;
  Str(ActScaleSet.LogToWorld(Y):3:2, NumStr);
  YLab.Caption:= NumStr;
end;

procedure TForm1.cdDrawbox1ScaleChange(Sender: TObject);
begin
  ScaleLab.Caption:= 'M 1 : ' + IntToStr(cdDrawbox1.ScaleSetting.rcp_scale);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  cdDrawbox1.SetScale(0);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 ScaleLab.Caption:= 'M 1 : ' + IntToStr(cdDrawbox1.ScaleSetting.rcp_scale);
end;

end.
