{*******************************************************}
{*  CadoDraw for Delphi examples                   *}
{*  Copyright (c) 1997 Alfred Lorenz                   *}
{*  All Rights Reserved                                *}
{*  internet mail support@LTS-Tools.com                *}
{*  word wide web http://www.LTS-Tools.com             *}
{*                                                     *}
{*  You are not allowed to redistribute this           *}
{*  code or any part of it                             *}
{*******************************************************}

unit StretchF;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Markmove, Cadodraw, StdCtrls, ExtCtrls, Buttons,
  Scl12;

  
// Verwendete Komponenten:
// cdDrawbox
//   Eigenschaften: Align alClient;
//                  Color clPurple;
// cdPoints
//   Eigenschaften: Generator.Brush.Color clBlack;
//                  Generator.HotSpotX,Y 10;
// LineDepends
//   Eigenschaften: Generator.Options [goStretchPicture];
//                  Generator.Picture Schaukel.BMP;
//                  MasterObject cdPoints1;
//   Ereignisse:    OnDynaShapeStart;
//                  OnDynaShapeMove;
//                  OnDynaShapeEnd;
// MarkMove
//  Eigenschaften:  Options [toDefaultTool];
//  Ereignisse:     OnObjectStartMove;
//                  OnObjectMove;
//                  OnObjectEndMove;




type
  TForm1 = class(TForm)
    BLab: TPanel;
    RButton: TButton;
    PButton: TButton;
    WTTL: TLabel;
    WLab: TLabel;
    HTTL: TLabel;
    HLab: TLabel;
    cdDrawbox1: TcdDrawbox;
    Dragbox: TcdPoints;
    Pict: TLineDepends;
    MarkMove1: TMarkMove;
    tcdDataModule1: tcdDataModule;
    HelpBtn1: TBitBtn;
    Rect: TLineDepends;
    Button3: TButton;
    SaveBtn: TButton;
    LoadBtn: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure PictDynaShapeMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure PictDynaShapeStart(Sender: TObject);
    procedure PictDynaShapeEnd(Sender: TObject);
    procedure MarkMove1ObjectStartMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure MarkMove1ObjectEndMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure MarkMove1ObjectMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PictDynaShapeMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  WLab.Caption:= IntToStr(x);
  HLab.Caption:= IntToStr(y);
end;

procedure TForm1.PictDynaShapeStart(Sender: TObject);
begin
  WTTL.visible:= true;
  WLab.visible:= true;
  HTTL.visible:= true;
  HLab.visible:= true;
end;

procedure TForm1.PictDynaShapeEnd(Sender: TObject);
begin
  WTTL.visible:= false;
  WLab.visible:= false;
  HTTL.visible:= false;
  HLab.visible:= false;
end;

Var MarkedPic: tcdObject;

procedure TForm1.MarkMove1ObjectStartMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var I: Integer;
begin
  I:= 0;
  With cdDrawbox1.DataModule.Markcase do
  repeat
    if tcdObject(Items[I]) is tLineObj then MarkedPic:= Items[I]
    else inc(I);
  until (MarkedPic <> NIL) or (I = Count);
  PictDynaShapeStart(Sender);
end;

procedure TForm1.MarkMove1ObjectEndMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  PictDynaShapeEnd(Sender);
  MarkedPic:= NIL;
end;

procedure TForm1.MarkMove1ObjectMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if MarkedPic <> NIL then
  begin
    WLab.Caption:= IntToStr(MarkedPic.Width);
    HLab.Caption:= IntToStr(MarkedPic.Height);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  tcdDataModule1.DeleteObjects;
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
Var Stream: TStream;
begin
  if SaveDialog1.execute then
  begin
    Stream:= tFileStream.create(SaveDialog1.FileName, fmCreate);
    cdDrawBox1.DataModule.SaveToStream(Stream);
    Stream.Free;
  end;
end;

procedure TForm1.LoadBtnClick(Sender: TObject);
Var Stream: TStream;
begin
  if OpenDialog1.execute then
  begin
    Stream:= tFileStream.create(OpenDialog1.FileName, fmOpenRead);
    try
      cdDrawBox1.DataModule.LoadFromStream(Stream);
    finally
      Stream.Free;
    end;
  end;
end;

end.
